/****************************************************************
* Fondamenti di Informatica - Implementazione di uno Stack		*
* Uso di una struttura a vettore								*
* Metodi: Push - Pop											*
****************************************************************/

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "conio.h"
#include "float.h"
#include "math.h"

#define DIMSTK 5


/**************************************************************

 0  |_____|	
	|_____|	
	|_____|
	|_____|
	|_____|
	|_____|
n-2	|_____|
n-1	|_____|<-- TOS (Top Of Stack) = n-1
  

  PUSH(x), PUSH(y), PUSH(z), PUSH(w), PUSH(a)
  
  
 0  |_____|	
	|_____|
	|_____|<-- TOS (Top Of Stack) = n-6
n-5	|__A__|
	|__W__|	
	|__Z__|
n-2	|__Y__|
n-1	|__X__|


  POP() ---> A
  
 0  |_____|	
	|_____|
	|_____|<-- TOS (Top Of Stack) = n-5
	|__W__|	
	|__Z__|
n-2	|__Y__|
n-1	|__X__|


***************************************************************/


class Stack
{
	int tos; // top of stack 
	float corpo[DIMSTK];
public:
	Stack();
	int push(float a); // inserisci un elemento
	int pop(float * a); // estrai un elemento 
	int isempty(void); // verifica se e' vuoto
        void stampa(void); // stampa
};

/**********************IMPLEMENTAZIONE METODI************************/

Stack::Stack() 
  { 
	int i;   
	tos=DIMSTK-1;  
	for (i=0;i<DIMSTK;i++) corpo[i]=0.0; 
  }

int Stack::push(float a)  // inserisci un elemento
{
	if (tos>=0) //c'e' posto
	  { 
		corpo[tos]=a; 
		tos--;
		return(0);
	  }
	return(1);
}

int Stack::pop(float * a) // estrai un elemento 
{
	if (tos<DIMSTK-1)
	  { 
		tos++; 
		*a = corpo[tos];
		corpo[tos]=0.0; // cancellazione del contenuto [opzionale]
		return(0);
	  }
	return(1);
}

void Stack::stampa(void)  
{
	int i;
	printf("-------Stack--------\n");
	for (i=0;i<DIMSTK;i++)
	{ 
		printf("%d) %f\n",i, corpo[i]);
	}
	printf("tos %d \n", tos);
}

int Stack::isempty(void) 
  { 
	if (tos==DIMSTK-1) 
		return(1); 
	else 
		return(0); }

/********************************************************************/

void main(void)
{	
	char c;
	int ret, flg=0;
	float val;
	Stack stk;
	do {
	   printf("\nStack, operazioni: \n\n");
	   printf("a) push \n");
	   printf("b) pop \n");
	   printf("c) stampa \n");
	   printf("d) isempty \n");
	   printf("q) esci \n\n"); 
	   printf("Premi un tasto: ");
	   c=getch();
	   printf("\n");
	   switch(c)
		  { 
			case'a': case 'A':
				 printf("valore da inserire %f:"); scanf("%f",&val);
				 ret=stk.push(val);
				 if (ret!=0) printf("Stack pieno!\n"); 
				 break;
			case 'b':  case 'B': 
				 ret=stk.pop(&val);
				 if (ret!=0) printf("Stack vuoto!\n"); 
				 else printf("Valore estratto %f\n", val);
				 break;
			case 'c':  case 'C': 
				 printf("Stampa \n");
				 stk.stampa();
				 break;
			case 'd':  case 'D': 
				 ret=stk.isempty();
				 if (ret) printf("Lo stack e' vuoto \n");
				 break;
			case 'q':  case 'Q': 
				 flg=1;
				 break; // uscita
			default: printf("Operazione non consentita \n"); break;
		  }  
	   if (flg==0)
		  { 
			printf("Premi un tasto per un'altra operazione\n"); 
			getch(); 
		  }
	} while (flg!=1);
}

/***************************************************************/




